
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Spark Core源码分析: Spark任务执行模型 / iVAN</title>

    <meta name="description" content="Spark Core源码分析: Spark任务执行模型 DAGScheduler 面向stage的调度层,为job生成以stage组成的DAG,提交TaskSet给TaskScheduler执行. 每一个Stage内,都是独立的tasks,他们共同执行同一个compute function,享有相同的shuffledependencies.DAG在切分stage的时候是依照出现shuffle为界限的. private[spark] class DAGScheduler( taskScheduler: TaskScheduler, listenerBu">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Spark Core源码分析: Spark任务执行模型</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h1>DAGScheduler</h1>
<p>面向stage的调度层，为job生成以stage组成的DAG，提交TaskSet给TaskScheduler执行。</p>
<p>每一个Stage内，都是独立的tasks，他们共同执行同一个compute function，享有相同的shuffledependencies。DAG在切分stage的时候是依照出现shuffle为界限的。</p>
<pre>private[spark]
class DAGScheduler(
    taskScheduler: TaskScheduler,
    listenerBus: LiveListenerBus,
    mapOutputTracker: MapOutputTrackerMaster,
    blockManagerMaster: BlockManagerMaster,
    env: SparkEnv)
  extends Logging {
</pre>
<p><pre>// Actor模式收取发来的DAGSchedulerEvent，并进行processEvent
private var eventProcessActor: ActorRef = _

  private[scheduler] val nextJobId = new AtomicInteger(0)
  private[scheduler] def numTotalJobs: Int = nextJobId.get()
  private val nextStageId = new AtomicInteger(0)

  // 一系列信息维护，很清晰
  private[scheduler] val jobIdToStageIds = new HashMap[Int, HashSet[Int]]
  private[scheduler] val stageIdToJobIds = new HashMap[Int, HashSet[Int]]
  private[scheduler] val stageIdToStage = new HashMap[Int, Stage]
  private[scheduler] val shuffleToMapStage = new HashMap[Int, Stage]
  private[scheduler] val jobIdToActiveJob = new HashMap[Int, ActiveJob]
  private[scheduler] val resultStageToJob = new HashMap[Stage, ActiveJob]
  private[scheduler] val stageToInfos = new HashMap[Stage, StageInfo]

  // 不同状态stages的维护，很清晰
  // Stages we need to run whose parents aren't done
  private[scheduler] val waitingStages = new HashSet[Stage]

  // Stages we are running right now
  private[scheduler] val runningStages = new HashSet[Stage]

  // Stages that must be resubmitted due to fetch failures
  private[scheduler] val failedStages = new HashSet[Stage]

  // Missing tasks from each stage
  private[scheduler] val pendingTasks = new HashMap[Stage, HashSet[Task[_]]]

  private[scheduler] val activeJobs = new HashSet[ActiveJob]

  // Contains the locations that each RDD's partitions are cached on
  private val cacheLocs = new HashMap[Int, Array[Seq[TaskLocation]]]
</pre>
<p>在start()方法中会初始化Actor，然后接收DAGSchedulerEvent处理。Scheduler会在SparkContext里start起来。</p>
<h2>Event处理</h2>
<p>源码的阅读入口：可以根据processEvent(event:DAGSchedulerEvent)方法展开。</p>
<p>处理的事件包括这么一些：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA0MjAxMjIxMjQ4NTk/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Y0dWc2FXTnIvZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9DZW50ZXI=.jpg"></p>
<h3>Submit Job</h3>
<p>JobSubmitted事件：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA0MjAxMjIyMjg1MzE/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Y0dWc2FXTnIvZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9DZW50ZXI=.jpg"></p>
<p>提交任务的事件传入参数如下</p>
<pre>case JobSubmitted(jobId, rdd, func, partitions, allowLocal, callSite, listener, properties)</pre>
<p>处理过程可以拆成三步看，每一步里面涉及的具体逻辑在下面补充展开</p>
<pre>finalStage = newStage(rdd, partitions.size, None, jobId, Some(callSite))</pre>
<p>本次newStage()操作可以对应新的result stage或者shuffle stage。返回Stage类(里面记录一些信息)。Stage类会传入Option[ShuffleDependency[_,_]]参数，内部有一个isShuffleMap变量，以标识该Stage是shuffle or result。</p>
<pre>val job = new ActiveJob(jobId, finalStage, func, partitions, callSite, listener, properties)</pre>
<p>ActiveJob类也是记录一些信息的类，可以当作是一个VO类</p>
<pre>if (allowLocal &amp;&amp; finalStage.parents.size == 0 &amp;&amp; partitions.length == 1) {
// Compute very short actions like first() or take()
// with no parent stages locally.
listenerBus.post(SparkListenerJobStart(
job.jobId, Array[Int](), properties))
runLocally(job)
} else {
jobIdToActiveJob(jobId) = job
activeJobs += job
resultStageToJob(finalStage) = job
listenerBus.post(
SparkListenerJobStart(
job.jobId, jobIdToStageIds(jobId).toArray, properties))
submitStage(finalStage)
}
</pre>
<p>首先判断stage没有父亲依赖，且partition为1的话，就执行本地任务。否则，submitStage。</p>
<p> </p>
<p>submitStage的逻辑为，首先寻找本次stage的parents。如果没有missing的parent stage，那么就submitMissingTask,即提交本次stage的tasks了。如果有，会对parent stage进行递归submitStage，而且getMissingParentStages得到的结果集是按id降序排的，也就是说递归submitStage的时候会按parent stage的id顺序进行。</p>
<p> </p>
<p>submitMissingTask处理的是stage的parent已经available的stage。主要逻辑如下：</p>
<p>第一步：通过stage.isShuffleMap来决定生成ShuffleMapTask还是ResultTask，生成的ShuffleMapTask数目和partition数目相等。</p>
<p>第二步：把生成的tasks组建成一个TaskSet，提交给TaskScheduler的submitTasks方法。</p>
<h1>TaskScheduler</h1>
<p>DAGScheduler以stage为单位，提tasks给TaskScheduer，实现类为TaskSchedulerImpl。</p>
<p> </p>
<p>TaskSchedulerImpl几个内部部件：</p>
<p>SchedulerBackend</p>
<p>SchedulableBuilder</p>
<p>DAGScheduler</p>
<p>TaskSetManager</p>
<p>TaskResultGetter</p>
<p>Tasks信息（taskIdToTaskSetId，taskIdToExecutorId，activeExecutorIds）</p>
<p>别的信息（SchedulerMode）</p>
<p> </p>
<p>TaskScheduler做接收task、接收分到的资源和executor、维护信息、与backend打交道、把任务分配好等事情。</p>
<p> </p>
<p>start()，stop()的时候，backend的start()，stop()</p>
<p>submitTasks(TaskSet)逻辑：</p>
<p>为这批Task生成新的TaskSetManager，把TaskSetManager加到SchedulerBuilder里，然后向backend进行一次reviveOffer()操作。</p>
<h2>SchedulerBuilder</h2>
<p>SchedulableBuilder有FIFO和Fair两种实现， addTaskSetManager会把TaskSetManager加到pool里。FIFO的话只有一个pool。Fair有多个pool，Pool也分FIFO和Fair两种模式。</p>
<p>SchedulableBuilder的rootPool里面可以新增pool或者TaskSetManager，两者都是Scheduable的继承类，所以SchedulableBuilder用于维护rootPool这棵Scheduable 树结构。Pool是树上的非叶子节点，而TaskSetManager就是叶子节点。</p>
<p>在TaskScheduler初始化的时候会buildDafaultPool。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA0MjAxMjI3Mjg0Mzc/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Y0dWc2FXTnIvZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9DZW50ZXI=.jpg">                            <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA0MjAxMjI3MzM2NDA/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Y0dWc2FXTnIvZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9DZW50ZXI=.jpg"></p>
<h2>TaskSetManager</h2>
<p>TaskSetManager负责这批Tasks的启动，失败重试，感知本地化等事情。每次reourseOffer方法会寻找合适(符合条件execId, host, locality)的Task并启动它。</p>
<p> </p>
<p>reourseOffer方法，</p>
<pre>  def resourceOffer(
      execId: String,
      host: String,
      maxLocality: TaskLocality.TaskLocality)
</pre>
<p>寻找符合execId, host和locality的task，找到的话就启动这个Task。启动的时候，把task加到runningTask的HashSet里，然后调DAGScheduler的taskStarted方法，taskStarted方法向eventProcessorActor发出BeginEvent的DAGSchedulerEvent。</p>
<h2>TaskResultGetter</h2>
<p>维护一个线程池，用来反序列化和从远端获取task结果。</p>
<pre>def enqueueSuccessfulTask(taskSetManager: TaskSetManager, tid: Long, serializedData: ByteBuffer)</pre>
<p>把序列化的数据反序列化解析出来之后，有两种情况：直接可读的result和间接task result。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA0MjAxMjI4NDYzMTI/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Y0dWc2FXTnIvZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9DZW50ZXI=.jpg"></p>
<p>前者是DirectTaskResult[T]类：</p>
<pre>class DirectTaskResult[T](var valueBytes: ByteBuffer, var accumUpdates: Map[Long, Any], var metrics: TaskMetrics)</pre>
<p>后者是IndirectTaskResult[T]类：</p>
<pre>case class IndirectTaskResult[T](blockId: BlockId) extends TaskResult[T] with Serializable</pre>
<p>在反解析出IndirectTaskResult后，可以得到BlockId这个类，他的实现有这么些：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA0MjAxMjI5MzE0MDY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Y0dWc2FXTnIvZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9DZW50ZXI=.jpg"></p>
<p>在TaskResultGetter里，会通过blockManager的getRemoteBytes(BlockId)方法来获得序列化的task result，对这个task result进行反解析后得到DirectTaskResult类，从而获得反序列化后的真正结果数据。</p>
<p>这是大致的一个过程，具体还有一些细节在之中，比如会向scheduler发送不同的event、blockManager会调用BlockManagerMaster把该Block remove掉。</p>
<p> </p>
<p>BlockId类有这么些关键变量：</p>
<pre>private[spark] sealed abstract class BlockId {
  /** A globally unique identifier for this Block. Can be used for ser/de. */
  def name: String

  // convenience methods
  def asRDDId = if (isRDD) Some(asInstanceOf[RDDBlockId]) else None
  def isRDD = isInstanceOf[RDDBlockId]
  def isShuffle = isInstanceOf[ShuffleBlockId]
  def isBroadcast = isInstanceOf[BroadcastBlockId]
</pre>
<p>下面看BlockManager如何通过BlockId获得数据：</p>
<p>调用的是BlockManager的内部方法</p>
<pre>private def doGetRemote(blockId: BlockId, asValues: Boolean): Option[Any] = {
require(blockId != null, "BlockId is null")
// 通过BlockManagerMaster获得这个blockId的locations
    val locations = Random.shuffle(master.getLocations(blockId))
    for (loc &lt;- locations) {
      logDebug("Getting remote block " + blockId + " from " + loc)
      // 使用BlockManagerWorker来获得block的数据
      val data = BlockManagerWorker.syncGetBlock(
        GetBlock(blockId), ConnectionManagerId(loc.host, loc.port))
      if (data != null) {
        if (asValues) {
          // 取到就返回
          return Some(dataDeserialize(blockId, data))
        } else {
          return Some(data)
        }
      }
      logDebug("The value of block " + blockId + " is null")
    }
    logDebug("Block " + blockId + " not found")
    None
  }
</pre>
<p>思路是通过BlockManagerMaster来获得block的位置信息，得到的集合打乱后，遍历位置信息，通过BlockManagerWorker去获得数据，只要得到了，就反序列化之后返回。</p>
<p> </p>
<p>在TaskResultGetter处理的时候，成功和失败分别向Scheduler调用handleSuccessfulTask和handleFailedTask方法。</p>
<p>handleSuccessfulTask在DAGScheduler里，会发出CompletionEvent事件，这一步结尾工作会有很多细节处理，这里先不阅读了。</p>
<p>handleFailedTask的话，只要TaskSetManager不是zombie，task没有被kill，那么会继续调用backend.reviveOffers()来re-run。</p>
<p>全文完 :)</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-17 12:14:34</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Spark Core源码分析: Spark任务执行模型的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxWkePb.html" rel="bookmark">Spark Core源码分析&colon; Spark任务模型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 一个Spark的Job分为多个stage,最后一个stage会包括一个或多个ResultTask,前面的stages会包括一个或多个ShuffleMapTasks. ResultTask执行并将结果返回给driver application. ShuffleMapTask将task的output根据task的partition分离到多个buckets里.一个ShuffleMapTask对应一个ShuffleDependency的partition,而总partition数同并行度.redu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmBY07z.html" rel="bookmark">Spark Core源码分析&colon; RDD基础</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				RDD RDD初始参数:上下文和一组依赖 abstract class RDD[T: ClassTag]( @transient private var sc: SparkContext, @transient private var deps: Seq[Dependency[_]] ) extends Serializable 以下需要仔细理清: A list of Partitions Function to compute split (sub RDD impl) A list of De			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeLLewp.html" rel="bookmark">Spark 源码分析 -- task实际执行过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spark源码分析 – SparkContext 中的例子, 只分析到sc.runJob 那么最终是怎么执行的? 通过DAGScheduler切分成Stage, 封装成taskset, 提交给TaskScheduler, 然后等待调度, 最终到Executor上执行 val sc = new SparkContext(--) val textFile = sc.textFile(&quot;README.md&quot;) textFile.filter(line =&gt; line.contains(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bam3Zqb.html" rel="bookmark">Spark Catalyst 源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Architecture Ø 把输入的SQL,parse成unresolved logical plan,这一步参考SqlParser的实现 Ø 把unresolved logical plan转化成resolved logical plan,这一步参考analysis的实现 Ø 把resolved logical plan转化成optimized logical plan,这一步参考optimize的实现 Ø 把optimized logical plan转化成physical plan,这一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqAmNKM.html" rel="bookmark">Pig源码分析&colon; 简析执行计划的生成</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘要 本文通过跟代码的方式,分析从输入一批Pig-latin到输出物理执行计划(与launcher引擎有关,一般是MR执行计划,也可以是Spark RDD的执行算子)的整体流程. 不会具体涉及AST如何解析.如何使用了Anltr.逻辑执行计划如何映射.逻辑执行计划如何优化.MR执行计划如何切分为MR Job,而是从输入一批Pig DSL到待执行的真正执行计划的关键变化步骤(方法和类). 执行计划完整解析 入口处书Main类的main函数 /** * The Main-Class for the			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPkxQ1M.html" rel="bookmark">Spark源码分析 &ndash; SparkContext</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spark源码分析之-scheduler模块  这位写的非常好, 让我对Spark的源码分析, 变的轻松了许多  这里自己再梳理一遍 先看一个简单的spark操作, val sc = new SparkContext(--) val textFile = sc.textFile(&quot;README.md&quot;) textFile.filter(line =&gt; line.contains(&quot;Spark&quot;)).count()   1. SparkContext 这是Spa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5AABDp.html" rel="bookmark">Jquery源码分析---导言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				jQuery是一个非常优秀的JS库,与Prototype,YUI,Mootools等众多的Js类库 相比,它剑走偏锋,从web开发的实用角度出发,抛除了其它Lib中一些中看但不 实用的东西,为开发者提供了优美短小而精悍的类库.其使用简单,文档丰富, 而且性能高效,能极大地提高web系统的开发效率.因此可以说是web应用开发中 最佳的Js辅助类库之一.大部分开发者正在抛弃Prototype,而选择Jquery做为 他们进行web开发的JS库. 如是开发人员仅仅只知道文档中的简单的使用 方法,却不明			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b32amWz.html" rel="bookmark">深入理解Spark：核心思想与源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				大数据技术丛书 深入理解Spark:核心思想与源码分析 耿嘉安 著 图书在版编目(CIP)数据 深入理解Spark:核心思想与源码分析/耿嘉安著. -北京:机械工业出版社,2015.12 (大数据技术丛书) ISBN 978-7-111-52234-8 I. 深- II.耿- III.数据处理软件 IV. TP274 中国版本图书馆CIP数据核字(2015)第280808号 深入理解Spark:核心思想与源码分析 出版发行:机械工业出版社(北京市西城区百万庄大街22号 邮政编码:100037)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze6l2Ob.html" rel="bookmark">Spark源码分析 &ndash; Shuffle</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				参考详细探究Spark的shuffle实现, 写的很清楚, 当前设计的来龙去脉   Hadoop Hadoop的思路是, 在mapper端每次当memory buffer中的数据快满的时候, 先将memory中的数据, 按partition进行划分, 然后各自存成小文件, 这样当buffer不断的spill的时候, 就会产生大量的小文件  所以Hadoop后面直到reduce之前做的所有的事情其实就是不断的merge, 基于文件的多路并归排序, 在map端的将相同partition的merge到			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBKrKM.html" rel="bookmark" class="title">百度动物园的前面有个千亿市场</a>
					<div>
						互联网八卦多,人们也爱看八卦,热衷于打来打去,尤其是爱看大公司大手笔收购和花钱.可是真的到了一些重要时刻,例如公司的战略调整和业务布局,受众反而不那么敏感了.前一阵子阿里和腾讯花了很多钱收购,百度也成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9AORM.html" rel="bookmark" class="title">网页设计小技巧&colon;解决IE6不支持hover</a>
					<div>
						文章简介:网页设计小技巧:解决IE6不支持hover.  IE6以及更低版本的浏览器对&quot;:hover&quot;的支持不理想,对于类似的&quot;p:hover&quot;.&quot;i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zGRPvp.html" rel="bookmark" class="title">通用存储过程的编写</a>
					<div>
						存储过程 通用存储过程的编写 对数据库的操作基本上就四种:Insert.Update.Delete和Select,而Update和Insert两种操作又可以作简单的合并,这样下来,基本上一个数据表对应 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJ55qp.html" rel="bookmark" class="title">磁盘格式化的编程实现</a>
					<div>
						编程 盘格式化是计算机用户经常使用的操作之一,但由于操作系统的控制台和外壳(Shell)提供了对格式化的完美支持,使编程人员很容易忽视用户对格式化的基本需求.在他们看来,磁盘格式化对用户来说并不是一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVvOKz.html" rel="bookmark" class="title">20个绝密QQ技巧</a>
					<div>
						1.让电脑只能上到自己的QQ,任何QQ都无法登陆.首先把自己的QQ设置为自动登陆模式,接下来最关键的就是移动或删除QQ主目录下的WizardCtrl.dll文件,这样就算别的QQ怎么样也登陆不了的了. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62NmYM.html" rel="bookmark" class="title">Cisco路由器的密码恢复方法</a>
					<div>
						1.启动路由器,启动过程中,按住&quot;Ctrl+Break&quot;键.这时系统会进入灾难恢复模式,其提示符为: rommon 1 &gt; 2.修改寄存器的值为0x2142 rommon 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jGEPb.html" rel="bookmark" class="title">Excel 2007提示&colon;There was a problem sending the command to the program</a>
					<div>
						症状:用户打开任何Excel文件都弹出这个错误提示:There was a problem sending the command to the program,如图: 原因:设置及软件冲突 解决方法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7Roab.html" rel="bookmark" class="title">识破用WinRAR捆绑的木马</a>
					<div>
						随着人们安全意识的提高,木马的生存越来越成为问题,木马种植者当然不甘心木马就这样被人所发觉,于是他们想出许多办法来伪装隐藏自己的行为,利用WinRAR捆绑木马就是其中的手段之一.那么我们怎么才能识别出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXByNKb.html" rel="bookmark" class="title">苍老师百度输入法在哪下载？</a>
					<div>
						  苍老师输入法视频演示: http://video.weibo.com/show?fid=1034:a78081e27ef458b910de2e1af96d9b58 首先这是一个手机输入法的皮肤主题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLkdkb.html" rel="bookmark" class="title">Word2007快速拆分表格，将其一分为二</a>
					<div>
						复杂的表格我们一般用Excel来完成,但是简单的表格我们往往会采用Word来制作.虽说Word中的表格功能没有Excel中那样强大,但是对于我们完成一些基本的表格已经足以了.其实,Word表格还有许多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBK2QoM.html" rel="bookmark" class="title">Linux操作系统中内存buffer和cache的区别</a>
					<div>
						  free 命令相对于top 提供了更简洁的查看系统内存使用情况: $ free total used free shared buffers cached Mem: 255268 238332 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNVvoM.html" rel="bookmark" class="title">怎么不让Win7系统的窗口自动排列</a>
					<div>
						  在使用win7系统的过程中,有一个说好又不好的功能,那就窗口自动排列功能,用户只要把窗口拖到桌面顶端或是左右两侧,一放开,窗口就会自动放大,铺满整个桌面.如果有用户不习惯这样的操作,可以选择将之屏 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA72Y3z.html" rel="bookmark" class="title">javascript 页面划词搜索JS&lowbar;javascript技巧</a>
					<div>
						基于Jquery修改,以下为全部脚本 复制代码 代码如下: //划词搜索 var GLS = {}; GLS.startObj = null; GLS.isdb = false; GLS.allow  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYjgkxp.html" rel="bookmark" class="title">Oracle官方并发教程之中断</a>
					<div>
						原文链接,译文链接,译者: 蘑菇街-小宝   校对:梁海舰 中断是给线程的一个指示,告诉它应该停止正在做的事并去做其他事情.一个线程究竟要怎么响应中断请求取决于程序员,不过让其终止是很普遍的做法.这是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Q4lmp.html" rel="bookmark" class="title">MySQL &CenterDot; 引擎特性 &CenterDot; InnoDB 事务子系统介绍</a>
					<div>
						前言 在前面几期关于 InnoDB Redo 和 Undo 实现的铺垫后,本节我们从上层的角度来阐述 InnoDB 的事务子系统是如何实现的,涉及的内容包括:InnoDB的事务相关模块.如何实现MVC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8krnlM.html" rel="bookmark" class="title">如何及时刷新DATAGRIDVIEW的数据，在线等</a>
					<div>
						问题描述 我是一个C#的初学者,做了一个简单的添加程序,但是在添加完成后datagridview中不及时刷新数据,请各位高人指点一下.下图是添加程序的界面[img=http://b39.photo.s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRLE3p.html" rel="bookmark" class="title">混合云时代，备份数据的价值如何挖掘？</a>
					<div>
						今天的企业整个数据管理是一个什么样子?大家可以想象一下,从数据类型看,有交易数据.文档.图片.文本.邮件.音频.移动数据以及视频等.从基础架构看,从物理机到Windows.VMware虚拟化的出现,再 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqdVyz.html" rel="bookmark" class="title">&lbrack;LeetCode&rsqb;191&period;Number of 1 Bits</a>
					<div>
						题目 Write a function that takes an unsigned integer and returns the number of '1' bits it has (also k ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7Eqwp.html" rel="bookmark" class="title">java实现 用户&plus;公钥登录sftp</a>
					<div>
						问题描述 求助:如何用java功能包jcraft实现用用户名和配置的公钥登录sftp(不用登录密码验证了)?已经实现了以用户名+-密码方式登录sftp服务器,现在要改为以配置公钥的方式登录linux环 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZrAWM.html" rel="bookmark" class="title">easyui combogrid 默认选择一行 用onselect 就不能多选了</a>
					<div>
						问题描述 easyui combogrid 默认选择一行 用onselect 就不能多选了 默认的时候onselect 去掉默认的选择其他的值. 但是不可以多选了. 有什么是实现的方法 么 如这样 o ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Z5DDz.html" rel="bookmark" class="title">使用马克斯电影程序全部被百度搜索k 了</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 马克斯电影程序最近几年风靡草根界,一时间众多电影类网站全部换成马克斯电影程序.因为程序的轻便,和生存静态,以及程序的安全性,最大的好处是采集功能 在电影 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNnjeoM.html" rel="bookmark" class="title">get-winform使用webclient上传文件报错，是怎么回事？？？具体如下</a>
					<div>
						问题描述 winform使用webclient上传文件报错,是怎么回事???具体如下 到底是怎么回事??附上服务端代码 protected void Page_Load(object sender,  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNNBKM.html" rel="bookmark" class="title">别克凯越制动系统ABS泵一路油孔不出油</a>
					<div>
						本人07年8月购07款别克凯越SGM7161LE型轿车,至2011年7月13日年检时,行驶里程42000公里,验车过程中,因左后轮无制动而未通过年检,在4S店检查,发现ABS泵一路油孔不出油,4S店告 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeo0Q9M.html" rel="bookmark" class="title">mysql 获取当前日期及格式化</a>
					<div>
						MySQL 获取当前日期及日期格式 获取系统日期: NOW() 格式化日期: DATE_FORMAT(date, format) 注: date:时间字段 format:日期格式 返回系统日期,输出  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Y61xz.html" rel="bookmark" class="title">苹果365万美元买下i-Phone商标</a>
					<div>
						每经记者 许凤婷 任思强 发自成都.北京 从今日开始,汉王科技将进行为期3天的路演,近期将登陆深交所中小板上市. 从汉王科技近日发布的招股意向书中,记者昨日(2月2日)发现多项涉及知识产权.商标注册的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqxavp.html" rel="bookmark" class="title">《响应式Web设计：HTML5和CSS3实践指南》&mdash;&mdash;1&period;4节使视频自适应于屏幕宽度</a>
					<div>
						1.4 使视频自适应于屏幕宽度 流媒体视频同样可以为响应式的.在HTML5页面中嵌入响应式视频是一件非常简单的事情.如video标签支持百分比的宽度设置,但是问题在于,该方案需要网站主机拥有对应的视频 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAkr62z.html" rel="bookmark" class="title">苹果iOS 4&period;2新系统将增强iPad市场普及性</a>
					<div>
						苹果终于推出了市场期待已久的iOS 4.2新操作系统,目前已经可以让iPad.iPhone和http://www.aliyun.com/zixun/aggregation/11683.html&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGr1R3p.html" rel="bookmark" class="title">PHP如何编写易读的代码&lowbar;php技巧</a>
					<div>
						成功的开发团队要求队伍中的每一位成员遵守代码重用规则,这些规定把代码的重用性推到极至同时却不会显著降低开发人员的创造力和开发效率.如果编写和使用代码的开发人员遵守共同的程序命名规范代码和代码注释要求, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyW0gPz.html" rel="bookmark" class="title">AS3&period;0实例学习 熟悉新的事件机制和addChild的运用&lowbar;Flash As</a>
					<div>
						首先声明:本人大菜鸟一个,刚接触AS3不久,许多理念还没来得及灌输,这些case都是从网上down的,但因为解说是英文的,不利我们学习,我就充当一个translater,顺便可以让自己巩固一下知识.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL5x58z.html" rel="bookmark" class="title">之前在xp中配过jdk环境变量</a>
					<div>
						问题描述 之前在xp中配过jdk环境变量升级到win7后,只装了jdk却没配环境变量eclipse却可以使用?何解?. 解决方案 解决方案二:eclipse什么版本的?jdk什么版本的现在使用ecli ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
